
from pelican import signals

from .utils import modify_html


def register():
    signals.content_object_init.connect(attach_plain_summary)


def attach_plain_summary(content):
    if not content.source_path.endswith('.md'):
        return

    content.plain_summary = content.summary

    with modify_html(content, prop='plain_summary') as html_tree:
        queries = [
            '//iframe', '//object', '//p[count(img) = 1]',
            '//img', '//figure',
        ]
        for query in queries:
            for element in html_tree.xpath(query):
                element.getparent().remove(element)
